function love.load()
	players = {} -- Creating the players
	crackers = {}
	grid = {}
	gridXCount = 30
	gridYCount = 16
	cellSize = 64
	for x = 0,gridXCount-1 do -- The grid (to be implemented)
		grid[x] = {}
		for y = 0,gridYCount-1 do
			grid[x][y] = 0
		end
	end
	levelSpawn("level1")
	table.insert(players,{joined = true, x = 250, y = 250, dirx = 0, diry = 0, crackers = 0, health = 3, player = 1, control = nil, item = 1, quacktime = 0,w=32,h=32})
	table.insert(players,{joined = true, x = 250, y = 250, dirx = 0, diry = 0, crackers = 0, health = 3, player = 2, control = nil, item = 2, quacktime = 0,w=32,h=32})
	applyControl(1,"wasde") -- Charcter controls
	applyControl(2,"ijklo")
	applyControl(5,"ijklo")
	love.graphics.setBackgroundColor(0,0,1)
end

function love.update(dt)
	playerUpdate(dt)
	if love.keyboard.isDown("escape") then
		love.event.quit()
	end
end

function love.draw()
	levelDraw()
	playerDraw()
	local msg = "Current FPS: "..tostring(love.timer.getFPS())
	love.graphics.print(msg, 1920-200, 10)
end

function playerUpdate(dt)
	for i,o in pairs(players) do -- Player Identification
		if o.player > 4 then
			table.remove(players,i)
		end
		if o.player < 1 then
			table.remove(players,i)
		end
		if o.joined == true then
			item()
			o.quacktime = o.quacktime - dt
			local q,w,e,r,t = string.sub(o.control, 1, 1),string.sub(o.control, 2,2),string.sub(o.control, 3,3),string.sub(o.control, 4,4),string.sub(o.control, 5,5)
			if love.keyboard.isDown(q) then -- Controlling the players
				o.diry = o.diry - 0.25
			end
			if love.keyboard.isDown(w) then
				o.dirx = o.dirx - 0.25
			end
			if love.keyboard.isDown(e) then
				o.diry = o.diry + 0.25
			end
			if love.keyboard.isDown(r) then
				o.dirx = o.dirx + 0.25
			end
			local surface = 0.9
			if checkTile(o.x,o.y,15,15) == 2 then
				surface = 0.8
			elseif checkTile(o.x,o.y,15,15) == 3 then
				surface = 0.97
			end
			if checkTile(o.x+ o.dirx * dt * o.speed,o.y,15,15) == 4 then
				o.dirx = 0
			end
			if checkTile(o.x,o.y+ o.diry * dt * o.speed,15,15) == 4 then
				o.diry = 0
			end
			o.x = o.x + o.dirx * dt * o.speed -- Moving Players
			o.y = o.y + o.diry * dt * o.speed
			o.dirx = o.dirx * surface -- Reducing Velocity
			o.diry = o.diry * surface
			if love.keyboard.isDown(t) and o.quacktime <= 0 then -- Time reload for quack attack
				o.quacktime = o.quacktimeMax
				quack(o.player)
			end
		end
	end
end

function applyControl(player,control) -- Changing the player controls (possibly change for individual button changing)
	local works = false
	for i,o in pairs(players) do
		if o.player == player then
			works = true
		end
	end
	if works == false then
		print("Player "..player.." is not connected or allowed")
		return
	end
	for i,o in pairs(players) do
		local allowed = false
		if control == "wasde" then -- WASD Controls
			allowed = true
		elseif control == "ijklo" then -- IJKL Controls
			allowed = true
		end -- Add arrow keys and more control options (controllers)
		if o.player == player then
			if allowed == true then -- Checks if it is a working control system
				o.control = control
			else
				print("Control type "..control.." is not allowed")
			end
		end
	end
end

function playerDraw() -- Drawing the players (currently dots)
	for i,o in pairs(players) do
		if o.joined == true then
			love.graphics.setColor(o.player-1,o.player-1,o.player-1)
			love.graphics.rectangle("fill",o.x,o.y,o.w,o.h)
			love.graphics.print(o.range,100*o.player-90,10)
			love.graphics.print(o.quacktimeMax,100*o.player-90,30)
			love.graphics.print(math.floor(o.quacktime*100)/100,100*o.player-90,50)
			love.graphics.print(o.speed,100*o.player-90,70)
		end
	end
end

function quack(player) -- Quack Attack (player says which person is attacking)
	local x,y,range
	for i,o in pairs(players) do -- Makes sure knockback isn't applied to the player using the attack
		if o.player == player then
			x,y,range = o.x,o.y,o.range
		end
	end
	for i,o in pairs(players) do 
		if o.player == player then
		else
			local angle = math.atan2((y - o.y), (x - o.x)) -- The actual knockback
			local rangex = x - o.x
			local rangey = y - o.y
			local distance = math.sqrt(rangex^2+rangey^2)
			distance = (distance-range)/25
			if distance >= 0 then
				distance = 0
			end
			o.dirx = o.dirx + distance * math.cos(angle) 
			o.diry = o.diry + distance * math.sin(angle)
		end
	end
end

function item() -- Checking what item a player has and changing stats on it
	for i,o in pairs(players) do
		if o.item == 1 then -- Range bonus/minus
			o.range = 250
		elseif o.item == -1 then
			o.range = 150
		else
			o.range = 200
		end
		if o.item == 2 then -- Cooldown reduction/addition
			o.quacktimeMax = 2
		elseif o.item == -2 then
			o.quacktimeMax = 4
		else
			o.quacktimeMax = 3
		end
		if o.item == 3 then -- Speed bonus/minus
			o.speed = 250
		elseif o.item == -2 then
			o.speed = 150
		else
			o.speed = 200
		end
	end
end

function crackerSpawn()
	
end

local randomLevels = { -- Level list
	"level1"
}

function levelSpawn(level) -- Creating a level
	
	image0 = love.graphics.newImage("tiles/0.png")
	image1 = love.graphics.newImage("tiles/1.png")
	image2 = love.graphics.newImage("tiles/2.png")
	image3 = love.graphics.newImage("tiles/3.png")
	image4 = love.graphics.newImage("tiles/4.png")
	
	if level == nil then -- Choose random level if none is suplied
		level = randomLevels[love.math.random(1,#randomLevels)]
	end
	
	if level == "random" then
		level = randomLevels[love.math.random(1,#randomLevels)]
	end
	
	local image = love.image.newImageData("levels/"..level..".png") -- Checking the level
	offsetY = (1080 - cellSize * 16)/2 -- Creating the offset
	
	for x = 0, gridXCount-1 do -- Actual making the level
		for y = 0, gridYCount-1 do
			local r, g, b, a = image:getPixel(x,y)
			
			grid[x][y] = getTile(r,g,b)
		end
	end
			
end

function getTile(r,g,b)
	if r == 0 and g == 1 and b == 0 then -- Grass Tile
		return 1
	elseif r == 0 and g == 0 and b == 1 then -- Water/Death tile
		return 0
	elseif r == 1 and g == 0 and b == 0 then -- Sand tile
		return 2
	elseif r == 1 and g == 1 and b == 1 then -- Ice tile
		return 3
	elseif r == 0 and g ==0 and b == 0 then -- Wall
		return 4
	end
end

function levelDraw() -- Drawing the level
	for x = 0, gridXCount-1 do
		for y = 0, gridYCount-1 do
			love.graphics.setColor(255,255,255,255)
			if grid[x][y] == 1 then
				love.graphics.draw(image1,x*cellSize,y*cellSize+offsetY) -- Actual drawing
			elseif grid[x][y] == 2 then
				love.graphics.draw(image2,x*cellSize,y*cellSize+offsetY)
			elseif grid[x][y] == 3 then
				love.graphics.draw(image3,x*cellSize,y*cellSize+offsetY)
			elseif grid[x][y] == 4 then
				love.graphics.draw(image4,x*cellSize,y*cellSize+offsetY)
			elseif grid[x][y] == 0 then
				love.graphics.draw(image0,x*cellSize,y*cellSize+offsetY)
			end
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("line",x*cellSize,y*cellSize+offsetY,cellSize,cellSize)
		end
	end
end

function checkTile(q,w,e,r)
	for x = 0, gridXCount -1 do
		for y = 0, gridYCount -1 do
			if q < x*cellSize+cellSize and x*cellSize < q+e and w < y*cellSize+offsetY+cellSize and y*cellSize+offsetY < w+r then
				return grid[x][y]
			end
		end
	end
end